﻿Imports System.Collections.ObjectModel
Imports System.Globalization
Imports System.Linq
Imports System.ServiceModel
Imports Microsoft.Xrm.Sdk

Namespace NamespaceName

    Partial Public Class PluginClassName
        Inherits BasePluginClassName

        Public Sub New(unsecureConfig As String, secureConfig As String)
            MyBase.New(unsecureConfig, secureConfig)
            ' Register for any specific events by instantiating a new instance of the 'PluginEvent' class and registering it
            MyBase.RegisteredEvents.Add(New PluginEvent() With {
                .Stage = Stage.PostOperation,
                .MessageName = MessageNames.MessageNamesPlaceHolder,
                .TableName = TableNames.TableNamesPlaceHolder,
                .PluginAction = AddressOf ExecutePluginLogic
            })
        End Sub

        Public Sub ExecutePluginLogic(serviceProvider As IServiceProvider)
            ' Use a 'using' statement to dispose of the service context properly
            ' To use a specific early bound entity replace the 'Entity' below with the appropriate class type

            Using localContext = New LocalPluginContext(Of Entity)(serviceProvider)
                ' Todo: Place your logic here for the plugin

            End Using
        End Sub
    End Class
End Namespace
