﻿//declare module Xrm.FormBase {

//}

//declare module Xrm.Form {
//    interface Xrm<T extends PageBase<Forms.AttributeCollectionBase, Forms.TabCollectionBase, Forms.ControlCollectionBase>> {
//        /**
//         * The Xrm.Page object model, which contains data about the current page.
//         */
//        Page: T;
//        /**
//         * Various utility functions can be found here.
//         */
//        Utility: XrmRef.Utility;
//    }

//    interface PageBase<T extends Collection.AttributeCollection, U extends Collection.TabCollection, V extends Collection.ControlCollection> {
//        /**
//         * Data on the page.
//         */
//        data: DataModule<T>;
//        /**
//         * UI of the page.
//         */
//        ui: UiModule<U, V>;
//        /**
//         * The context of the page.
//         */
//        context: context;
//    }


//    /**
//     * A definition module for collection interface declarations.
//     */
//    export module Collection {
//        /**
//         * Interface for a matching delegate.
//         *
//         * @tparam  T   Generic type parameter.
//         */
//        interface MatchingDelegate<T> {
//            /**
//             * Called for each item in an array
//             *
//             * @param   {T} item            The item.
//             * @param   {number}    index   Zero-based index of the item array.
//             *
//             * @return  true if the item matches, false if it does not.
//             */
//            (item: T, index?: number): boolean;
//        }

//        /**
//         * Interface for iterative delegate.
//         *
//         * @tparam  T   Generic type parameter.
//         */
//        interface IterativeDelegate<T> {
//            /**
//             * Called for each item in an array
//             *
//             * @param   {T} item            The item.
//             * @param   {number}    index   Zero-based index of the item array.
//             */
//            (item: T, index?: number): void;
//        }

//        /**
//          * Interface for an item collection.
//          *
//          * @tparam  T   Generic type parameter.
//          */
//        interface ItemCollection<T> {
//            /**
//             * Applies an operation to all items in this collection.
//             *
//             * @param   {IterativeDelegate{T}}  delegate    An iterative delegate function
//             */
//            forEach(delegate: IterativeDelegate<T>): void;

//            /**
//             * Gets.
//             *
//             * @param   {MatchingDelegate{T}}   delegate    A matching delegate function
//             *
//             * @return  A T[] whose members have been validated by delegate.
//             */
//            get(delegate: MatchingDelegate<T>): T[];

//            /**
//             * Gets the item given by the index.
//             *
//             * @param   {number}    itemNumber  The item number to get.
//             *
//             * @return  The T in the itemNumber-th place.
//             */
//            get(itemNumber: number): T;

//            /**
//             * Gets the item given by the key.
//             *
//             * @param   {string}    itemName    The item name to get.
//             *
//             * @return  The T matching the key itemName.
//             * 
//             * @see {@link Xrm.Page.Control.getName()} for Control-naming schemes.
//             */
//            get(itemName: string): T;

//            /**
//             * Gets the entire array of T.
//             *
//             * @return  A T[].
//             */
//            get(): T[];

//            /**
//             * Gets the length of the collection.
//             *
//             * @return  The length.
//             */
//            getLength(): number;
//        }

//        interface AttributeCollection extends ItemCollection<AttributeBase> { }
//        interface TabCollection extends ItemCollection<TabBase> { }
//        interface ControlCollection extends ItemCollection<ControlBase> { }

//    }
//}